import Particle, { Description } from 'capsule-particle';
import React, { createElement, Dispatch } from 'react';
import { ReducerPayload } from './components/Updater';
export interface IProps {
    config: {
        type: string;
        props?: Record<string, any>;
        particleOption?: Record<string, any>;
    } & Description;
    register: Array<{
        type: string;
        component: ReactCreateElementCmpt;
    }>;
    loading?: React.ReactElement;
}
export declare type ReactCreateElements = ReactCreateElement[] | null;
export declare type ReactCreateElement = ReturnType<typeof createElement> | null;
export declare type ReactCreateElementCmpt = Parameters<typeof createElement>[0];
export declare type RegisterRef = {
    register: IProps['register'];
    registerMap: Record<string, Parameters<typeof createElement>[0]>;
};
export declare type ReactElementsRef = {
    children: Record<string, Array<ReturnType<typeof createElement>>>;
    element: Record<string, ReturnType<typeof createElement>>;
};
export declare type reactUpdateQuotoRef = Record<string, {
    data: ReducerPayload;
}>;
export declare type particleDispatchRef = Record<string, Dispatch<ReducerPayload>>;
export declare type ImperativeRef = RegisterRef & {
    getParticle: () => ReturnType<Particle['getParticle']> | undefined;
    getItem: (keys?: string[], dataType?: 'object' | 'array') => ReturnType<Particle['getItem']>;
    append: (key: string, config: IProps['config'] | IProps['config'][], order?: number | undefined) => ReturnType<Particle['append']>;
    remove: (keys: string[]) => ReturnType<Particle['remove']>;
    setItem: (key: string, data: Record<string, any>) => ReturnType<Particle['setItem']>;
    replace: (key: string, config: IProps['config']) => ReturnType<Particle['replace']>;
};
