/// <reference types="react" />
import { RegisterRef, ReactElementsRef, particleDispatchRef, reactUpdateQuotoRef, ImperativeRef } from '../types';
import { ParticleItem, CallbackStatusParam } from 'capsule-particle';
export declare type ControllerExtra = {
    registerRef: React.MutableRefObject<RegisterRef>;
    reactElementsRef: React.MutableRefObject<ReactElementsRef>;
    particleDispatchRef: React.MutableRefObject<particleDispatchRef>;
    reactUpdateQuotoRef: React.MutableRefObject<reactUpdateQuotoRef>;
    reactParticleRef: React.MutableRefObject<ImperativeRef>;
};
export declare function particleInitController(particleItem: ParticleItem, status: CallbackStatusParam, controllerExtra: ControllerExtra): void;
export declare function particleAppendController(particleItem: ParticleItem, status: CallbackStatusParam, controllerExtra: ControllerExtra): void;
export declare function particleRemoveController(particleItem: ParticleItem, status: CallbackStatusParam, controllerExtra: ControllerExtra): void;
export declare function particleSetItemController(particleItem: ParticleItem, status: CallbackStatusParam, controllerExtra: ControllerExtra): void;
export declare function particleReplaceController(particleItem: ParticleItem, status: CallbackStatusParam, controllerExtra: ControllerExtra): void;
export declare const controllers: {
    init: typeof particleInitController;
    append: typeof particleAppendController;
    remove: typeof particleRemoveController;
    setItem: typeof particleSetItemController;
    replace: typeof particleReplaceController;
};
export declare function bindParticleFunToConfig(config: ParticleItem, reactParticleRef: ControllerExtra['reactParticleRef']): void;
